#include <avr/io.h>

; AVR @ 4MHz

loop_cnt_1l = 24		; loop counter LSB
loop_cnt_1m = 25		; loop counter MSB
loop_cnt_2l	= 22		; help
loop_cnt_2m = 23

;***************************************************************************
;*
;*	func:	wait_x_100u
;*
;*	vars:	loop_cnt_1l, loop_cnt_1m
;*			loop_cnt_2l, loop_cnt_2m
;*
;*	0,25 s pro Takt bei 4 MHz
;***************************************************************************
.global wait_x_100u
.func wait_x_100u
wait_x_100u:
		push	loop_cnt_1l
		push	loop_cnt_1m
		push	loop_cnt_2l
		push	loop_cnt_2m
		mov	loop_cnt_2l,loop_cnt_1l		; Anzahl der Durchlufe: loop_cnt_1
		mov	loop_cnt_2m,loop_cnt_1m
l2loop:	ldi 	loop_cnt_1l,99			; 99: 1 s pro Schleifendurchlauf bei 4 MHz (4 Takte)
lcloop:	dec	loop_cnt_1l					; 1 Takt
		or	loop_cnt_1l,loop_cnt_1l		; 1 Takt
		brne	lcloop					; 2 Takte
		;or	loop_cnt_2l,loop_cnt_2l     ; Ab hier immer 7 Takte, am Ende bei 2m=0 -> 8 Takte
		cpi		loop_cnt_2m,0			; 1 Takt
		brne	sbcnt					; 1/2 Takte
		cpi		loop_cnt_2l,0			; 1 Takt
		breq	wend                    ; 1/2 Takte
sbcnt:	subi	loop_cnt_2l,1			; 1 Durchlauf bei 4 MHz fr 100 s   ; 1 Takt
		sbc		loop_cnt_2m,loop_cnt_1l	; Register 1l hier immer 0           ; 1 Takt
		rjmp	l2loop                  ; 2 Takte
wend:	pop	loop_cnt_2m
		pop loop_cnt_2l
		pop	loop_cnt_1m
		pop loop_cnt_1l
		ret
.endfunc

;***************************************************************************
;*
;*	func:	wait_x_075u
;*
;*	vars:	loop_cnt_1l, loop_cnt_1m
;*			loop_cnt_2l, loop_cnt_2m
;*
;***************************************************************************
; Bei Parameter n=0 dauert die Schleife 7,5 us
; Bei Parameter n>0 dauert die Schleife (n*2,75+5,5) us
.global wait_x_075u
.func wait_x_075u
wait_x_075u:
		push	loop_cnt_1l
		push	loop_cnt_1m
		push	loop_cnt_2l
		push	loop_cnt_2m
		mov	loop_cnt_2l,loop_cnt_1l		;Anzahl der Durchlufe: loop_cnt_1
		mov	loop_cnt_2m,loop_cnt_1m
l2loop2:ldi 	loop_cnt_1l,1			;1: 0.75 s pro Schleifendurchlauf bei 4 MHz (3 Takte)
lcloop2:dec	loop_cnt_1l
		;or	loop_cnt_1l,loop_cnt_1l
		brne	lcloop2
		;or	loop_cnt_2l,loop_cnt_2l
		cpi		loop_cnt_2m,0
		brne	sbcntm2
		cpi		loop_cnt_2l,0
		breq	wend2
sbcnt2:	subi	loop_cnt_2l,1
		sbc		loop_cnt_2m,loop_cnt_1l	;Register hier immer 0
		rjmp	l2loop2
sbcntm2:nop
		subi	loop_cnt_2l,1
		sbc		loop_cnt_2m,loop_cnt_1l	;Register hier immer 0
		rjmp	l2loop2
wend2:	pop	loop_cnt_2m
		pop loop_cnt_2l
		pop	loop_cnt_1m
		pop loop_cnt_1l
		ret
.endfunc

.global wait_x_1u
.func wait_x_1u
wait_x_1u:
		ret		; 1 s
.endfunc
.end
